Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/config.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -556,469 +627,4 @@
     }
   }
-};
-
-
-/** Initializes config file structure by loading elements from a give file.
- * \param *file input file stream being the opened config file
- * \param BondGraphFileName file name of the bond length table file, if string is left blank, no table is parsed.
- * \param *periode pointer to a periodentafel class with all elements
- * \param *&MolList pointer to MoleculeListClass, on return containing all parsed molecules in system
- */
-void config::Load(const char * const filename, const string &BondGraphFileName, const periodentafel * const periode, MoleculeListClass * const &MolList)
-{
-  molecule *mol = World::getInstance().createMolecule();
-  ifstream *file = new ifstream(filename);
-  if (file == NULL) {
-    DoeLog(1) && (eLog()<< Verbose(1) << "config file " << filename << " missing!" << endl);
-    return;
-  }
-  file->close();
-  delete(file);
-
-  // ParseParameterFile
-  class ConfigFileBuffer *FileBuffer = new ConfigFileBuffer(filename);
-
-  /* Oeffne Hauptparameterdatei */
-  int di = 0;
-  double BoxLength[9];
-  string zeile;
-  string dummy;
-  int verbose = 0;
-  
-  //TODO: This is actually sensible?: if (MaxOuterStep > 0)
-  ParseThermostats(FileBuffer);
-  
-  /* Namen einlesen */
-
-  // 1. parse in options
-  ParseForParameter(verbose,FileBuffer, "mainname", 0, 1, 1, string_type, (config::mainname), 1, critical);
-  ParseForParameter(verbose,FileBuffer, "defaultpath", 0, 1, 1, string_type, (config::defaultpath), 1, critical);
-  ParseForParameter(verbose,FileBuffer, "pseudopotpath", 0, 1, 1, string_type, (config::pseudopotpath), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"ProcPEGamma", 0, 1, 1, int_type, &(config::ProcPEGamma), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"ProcPEPsi", 0, 1, 1, int_type, &(config::ProcPEPsi), 1, critical);
-
-  if (!ParseForParameter(verbose,FileBuffer,"Seed", 0, 1, 1, int_type, &(config::Seed), 1, optional))
-    config::Seed = 1;
-
-  if(!ParseForParameter(verbose,FileBuffer,"DoOutOrbitals", 0, 1, 1, int_type, &(config::DoOutOrbitals), 1, optional)) {
-    config::DoOutOrbitals = 0;
-  } else {
-    if (config::DoOutOrbitals < 0) config::DoOutOrbitals = 0;
-    if (config::DoOutOrbitals > 1) config::DoOutOrbitals = 1;
-  }
-  ParseForParameter(verbose,FileBuffer,"DoOutVis", 0, 1, 1, int_type, &(config::DoOutVis), 1, critical);
-  if (config::DoOutVis < 0) config::DoOutVis = 0;
-  if (config::DoOutVis > 1) config::DoOutVis = 1;
-  if (!ParseForParameter(verbose,FileBuffer,"VectorPlane", 0, 1, 1, int_type, &(config::VectorPlane), 1, optional))
-    config::VectorPlane = -1;
-  if (!ParseForParameter(verbose,FileBuffer,"VectorCut", 0, 1, 1, double_type, &(config::VectorCut), 1, optional))
-    config::VectorCut = 0.;
-  ParseForParameter(verbose,FileBuffer,"DoOutMes", 0, 1, 1, int_type, &(config::DoOutMes), 1, critical);
-  if (config::DoOutMes < 0) config::DoOutMes = 0;
-  if (config::DoOutMes > 1) config::DoOutMes = 1;
-  if (!ParseForParameter(verbose,FileBuffer,"DoOutCurr", 0, 1, 1, int_type, &(config::DoOutCurrent), 1, optional))
-    config::DoOutCurrent = 0;
-  if (config::DoOutCurrent < 0) config::DoOutCurrent = 0;
-  if (config::DoOutCurrent > 1) config::DoOutCurrent = 1;
-  ParseForParameter(verbose,FileBuffer,"AddGramSch", 0, 1, 1, int_type, &(config::UseAddGramSch), 1, critical);
-  if (config::UseAddGramSch < 0) config::UseAddGramSch = 0;
-  if (config::UseAddGramSch > 2) config::UseAddGramSch = 2;
-  if(!ParseForParameter(verbose,FileBuffer,"DoWannier", 0, 1, 1, int_type, &(config::DoWannier), 1, optional)) {
-    config::DoWannier = 0;
-  } else {
-    if (config::DoWannier < 0) config::DoWannier = 0;
-    if (config::DoWannier > 1) config::DoWannier = 1;
-  }
-  if(!ParseForParameter(verbose,FileBuffer,"CommonWannier", 0, 1, 1, int_type, &(config::CommonWannier), 1, optional)) {
-    config::CommonWannier = 0;
-  } else {
-    if (config::CommonWannier < 0) config::CommonWannier = 0;
-    if (config::CommonWannier > 4) config::CommonWannier = 4;
-  }
-  if(!ParseForParameter(verbose,FileBuffer,"SawtoothStart", 0, 1, 1, double_type, &(config::SawtoothStart), 1, optional)) {
-    config::SawtoothStart = 0.01;
-  } else {
-    if (config::SawtoothStart < 0.) config::SawtoothStart = 0.;
-    if (config::SawtoothStart > 1.) config::SawtoothStart = 1.;
-  }
-  
-  if (ParseForParameter(verbose,FileBuffer,"DoConstrainedMD", 0, 1, 1, int_type, &(config::DoConstrainedMD), 1, optional))
-    if (config::DoConstrainedMD < 0) 
-      config::DoConstrainedMD = 0;
-  ParseForParameter(verbose,FileBuffer,"MaxOuterStep", 0, 1, 1, int_type, &(config::MaxOuterStep), 1, critical);
-  if (!ParseForParameter(verbose,FileBuffer,"Deltat", 0, 1, 1, double_type, &(config::Deltat), 1, optional))
-    config::Deltat = 1;
-  ParseForParameter(verbose,FileBuffer,"OutVisStep", 0, 1, 1, int_type, &(config::OutVisStep), 1, optional);
-  ParseForParameter(verbose,FileBuffer,"OutSrcStep", 0, 1, 1, int_type, &(config::OutSrcStep), 1, optional);
-  ParseForParameter(verbose,FileBuffer,"TargetTemp", 0, 1, 1, double_type, &(Thermostats->TargetTemp), 1, optional);
-  //ParseForParameter(verbose,FileBuffer,"Thermostat", 0, 1, 1, int_type, &(config::ScaleTempStep), 1, optional);
-  if (!ParseForParameter(verbose,FileBuffer,"EpsWannier", 0, 1, 1, double_type, &(config::EpsWannier), 1, optional))
-    config::EpsWannier = 1e-8;
-
-  // stop conditions
-  //if (config::MaxOuterStep <= 0) config::MaxOuterStep = 1;
-  ParseForParameter(verbose,FileBuffer,"MaxPsiStep", 0, 1, 1, int_type, &(config::MaxPsiStep), 1, critical);
-  if (config::MaxPsiStep <= 0) config::MaxPsiStep = 3;
-
-  ParseForParameter(verbose,FileBuffer,"MaxMinStep", 0, 1, 1, int_type, &(config::MaxMinStep), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"RelEpsTotalE", 0, 1, 1, double_type, &(config::RelEpsTotalEnergy), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"RelEpsKineticE", 0, 1, 1, double_type, &(config::RelEpsKineticEnergy), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"MaxMinStopStep", 0, 1, 1, int_type, &(config::MaxMinStopStep), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"MaxMinGapStopStep", 0, 1, 1, int_type, &(config::MaxMinGapStopStep), 1, critical);
-  if (config::MaxMinStep <= 0) config::MaxMinStep = config::MaxPsiStep;
-  if (config::MaxMinStopStep < 1) config::MaxMinStopStep = 1;
-  if (config::MaxMinGapStopStep < 1) config::MaxMinGapStopStep = 1;
-
-  ParseForParameter(verbose,FileBuffer,"MaxInitMinStep", 0, 1, 1, int_type, &(config::MaxInitMinStep), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"InitRelEpsTotalE", 0, 1, 1, double_type, &(config::InitRelEpsTotalEnergy), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"InitRelEpsKineticE", 0, 1, 1, double_type, &(config::InitRelEpsKineticEnergy), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"InitMaxMinStopStep", 0, 1, 1, int_type, &(config::InitMaxMinStopStep), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"InitMaxMinGapStopStep", 0, 1, 1, int_type, &(config::InitMaxMinGapStopStep), 1, critical);
-  if (config::MaxInitMinStep <= 0) config::MaxInitMinStep = config::MaxPsiStep;
-  if (config::InitMaxMinStopStep < 1) config::InitMaxMinStopStep = 1;
-  if (config::InitMaxMinGapStopStep < 1) config::InitMaxMinGapStopStep = 1;
-
-  // Unit cell and magnetic field
-  ParseForParameter(verbose,FileBuffer, "BoxLength", 0, 3, 3, lower_trigrid, BoxLength, 1, critical); /* Lattice->RealBasis */
-  double * cell_size = new double[6];
-  cell_size[0] = BoxLength[0];
-  cell_size[1] = BoxLength[3];
-  cell_size[2] = BoxLength[4];
-  cell_size[3] = BoxLength[6];
-  cell_size[4] = BoxLength[7];
-  cell_size[5] = BoxLength[8];
-  World::getInstance().setDomain(cell_size);
-  delete cell_size;
-  //if (1) fprintf(stderr,"\n");
-
-  ParseForParameter(verbose,FileBuffer,"DoPerturbation", 0, 1, 1, int_type, &(config::DoPerturbation), 1, optional);
-  ParseForParameter(verbose,FileBuffer,"DoOutNICS", 0, 1, 1, int_type, &(config::DoOutNICS), 1, optional);
-  if (!ParseForParameter(verbose,FileBuffer,"DoFullCurrent", 0, 1, 1, int_type, &(config::DoFullCurrent), 1, optional))
-    config::DoFullCurrent = 0;
-  if (config::DoFullCurrent < 0) config::DoFullCurrent = 0;
-  if (config::DoFullCurrent > 2) config::DoFullCurrent = 2;
-  if (config::DoOutNICS < 0) config::DoOutNICS = 0;
-  if (config::DoOutNICS > 2) config::DoOutNICS = 2;
-  if (config::DoPerturbation == 0) {
-    config::DoFullCurrent = 0;
-    config::DoOutNICS = 0;
-  }
-
-  ParseForParameter(verbose,FileBuffer,"ECut", 0, 1, 1, double_type, &(config::ECut), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"MaxLevel", 0, 1, 1, int_type, &(config::MaxLevel), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"Level0Factor", 0, 1, 1, int_type, &(config::Lev0Factor), 1, critical);
-  if (config::Lev0Factor < 2) {
-    config::Lev0Factor = 2;
-  }
-  ParseForParameter(verbose,FileBuffer,"RiemannTensor", 0, 1, 1, int_type, &di, 1, critical);
-  if (di >= 0 && di < 2) {
-    config::RiemannTensor = di;
-  } else {
-    fprintf(stderr, "0 <= RiemanTensor < 2: 0 UseNotRT, 1 UseRT");
-    exit(1);
-  }
-  switch (config::RiemannTensor) {
-    case 0: //UseNoRT
-      if (config::MaxLevel < 2) {
-        config::MaxLevel = 2;
-      }
-      config::LevRFactor = 2;
-      config::RTActualUse = 0;
-      break;
-    case 1: // UseRT
-      if (config::MaxLevel < 3) {
-        config::MaxLevel = 3;
-      }
-      ParseForParameter(verbose,FileBuffer,"RiemannLevel", 0, 1, 1, int_type, &(config::RiemannLevel), 1, critical);
-      if (config::RiemannLevel < 2) {
-        config::RiemannLevel = 2;
-      }
-      if (config::RiemannLevel > config::MaxLevel-1) {
-        config::RiemannLevel = config::MaxLevel-1;
-      }
-      ParseForParameter(verbose,FileBuffer,"LevRFactor", 0, 1, 1, int_type, &(config::LevRFactor), 1, critical);
-      if (config::LevRFactor < 2) {
-        config::LevRFactor = 2;
-      }
-      config::Lev0Factor = 2;
-      config::RTActualUse = 2;
-      break;
-  }
-  ParseForParameter(verbose,FileBuffer,"PsiType", 0, 1, 1, int_type, &di, 1, critical);
-  if (di >= 0 && di < 2) {
-    config::PsiType = di;
-  } else {
-    fprintf(stderr, "0 <= PsiType < 2: 0 UseSpinDouble, 1 UseSpinUpDown");
-    exit(1);
-  }
-  switch (config::PsiType) {
-  case 0: // SpinDouble
-    ParseForParameter(verbose,FileBuffer,"MaxPsiDouble", 0, 1, 1, int_type, &(config::MaxPsiDouble), 1, critical);
-    ParseForParameter(verbose,FileBuffer,"AddPsis", 0, 1, 1, int_type, &(config::AddPsis), 1, optional);
-    break;
-  case 1: // SpinUpDown
-    if (config::ProcPEGamma % 2) config::ProcPEGamma*=2;
-    ParseForParameter(verbose,FileBuffer,"PsiMaxNoUp", 0, 1, 1, int_type, &(config::PsiMaxNoUp), 1, critical);
-    ParseForParameter(verbose,FileBuffer,"PsiMaxNoDown", 0, 1, 1, int_type, &(config::PsiMaxNoDown), 1, critical);
-    ParseForParameter(verbose,FileBuffer,"AddPsis", 0, 1, 1, int_type, &(config::AddPsis), 1, optional);
-    break;
-  }
-
-  // IonsInitRead
-
-  ParseForParameter(verbose,FileBuffer,"RCut", 0, 1, 1, double_type, &(config::RCut), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"IsAngstroem", 0, 1, 1, int_type, &(config::IsAngstroem), 1, critical);
-  ParseForParameter(verbose,FileBuffer,"MaxTypes", 0, 1, 1, int_type, &(MaxTypes), 1, critical);
-  if (!ParseForParameter(verbose,FileBuffer,"RelativeCoord", 0, 1, 1, int_type, &(config::RelativeCoord) , 1, optional))
-    config::RelativeCoord = 0;
-  if (!ParseForParameter(verbose,FileBuffer,"StructOpt", 0, 1, 1, int_type, &(config::StructOpt), 1, optional))
-    config::StructOpt = 0;
-
-  // 2. parse the bond graph file if given
-  if (BG == NULL) {
-    BG = new BondGraph(IsAngstroem);
-    if (BG->LoadBondLengthTable(BondGraphFileName)) {
-      DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
-    } else {
-      DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
-    }
-  }
-
-  // 3. parse the molecule in
-  LoadMolecule(mol, FileBuffer, periode, FastParsing);
-  mol->SetNameFromFilename(filename);
-  mol->ActiveFlag = true;
-  MolList->insert(mol);
-
-  // 4. dissect the molecule into connected subgraphs
-  // don't do this here ...
-  //MolList->DissectMoleculeIntoConnectedSubgraphs(mol,this);
-  //delete(mol);
-
-  delete(FileBuffer);
-};
-
-/** Initializes config file structure by loading elements from a give file with old pcp syntax.
- * \param *file input file stream being the opened config file with old pcp syntax
- * \param BondGraphFileName file name of the bond length table file, if string is left blank, no table is parsed.
- * \param *periode pointer to a periodentafel class with all elements
- * \param *&MolList pointer to MoleculeListClass, on return containing all parsed molecules in system
- */
-void config::LoadOld(const char * const filename, const string &BondGraphFileName, const periodentafel * const periode, MoleculeListClass * const &MolList)
-{
-  molecule *mol = World::getInstance().createMolecule();
-  ifstream *file = new ifstream(filename);
-  if (file == NULL) {
-    DoeLog(1) && (eLog()<< Verbose(1) << "config file " << filename << " missing!" << endl);
-    return;
-  }
-  // ParseParameters
-
-  /* Oeffne Hauptparameterdatei */
-  int l = 0;
-  int i = 0;
-  int di = 0;
-  double a = 0.;
-  double b = 0.;
-  double BoxLength[9];
-  string zeile;
-  string dummy;
-  const element *elementhash[128];
-  int Z = -1;
-  int No = -1;
-  int AtomNo = -1;
-  int found = 0;
-  int verbose = 0;
-
-  mol->ActiveFlag = true;
-  MolList->insert(mol);
-  /* Namen einlesen */
-
-  ParseForParameter(verbose,file, "mainname", 0, 1, 1, string_type, (config::mainname), 1, critical);
-  ParseForParameter(verbose,file, "defaultpath", 0, 1, 1, string_type, (config::defaultpath), 1, critical);
-  ParseForParameter(verbose,file, "pseudopotpath", 0, 1, 1, string_type, (config::pseudopotpath), 1, critical);
-  ParseForParameter(verbose,file, "ProcsGammaPsi", 0, 1, 1, int_type, &(config::ProcPEGamma), 1, critical);
-  ParseForParameter(verbose,file, "ProcsGammaPsi", 0, 2, 1, int_type, &(config::ProcPEPsi), 1, critical);
-  config::Seed = 1;
-  config::DoOutOrbitals = 0;
-  ParseForParameter(verbose,file,"DoOutVis", 0, 1, 1, int_type, &(config::DoOutVis), 1, critical);
-  if (config::DoOutVis < 0) config::DoOutVis = 0;
-  if (config::DoOutVis > 1) config::DoOutVis = 1;
-  config::VectorPlane = -1;
-  config::VectorCut = 0.;
-  ParseForParameter(verbose,file,"DoOutMes", 0, 1, 1, int_type, &(config::DoOutMes), 1, critical);
-  if (config::DoOutMes < 0) config::DoOutMes = 0;
-  if (config::DoOutMes > 1) config::DoOutMes = 1;
-  config::DoOutCurrent = 0;
-  ParseForParameter(verbose,file,"AddGramSch", 0, 1, 1, int_type, &(config::UseAddGramSch), 1, critical);
-  if (config::UseAddGramSch < 0) config::UseAddGramSch = 0;
-  if (config::UseAddGramSch > 2) config::UseAddGramSch = 2;
-  config::CommonWannier = 0;
-  config::SawtoothStart = 0.01;
-
-  ParseForParameter(verbose,file,"MaxOuterStep", 0, 1, 1, double_type, &(config::MaxOuterStep), 1, critical);
-  ParseForParameter(verbose,file,"Deltat", 0, 1, 1, double_type, &(config::Deltat), 1, optional);
-  ParseForParameter(verbose,file,"VisOuterStep", 0, 1, 1, int_type, &(config::OutVisStep), 1, optional);
-  ParseForParameter(verbose,file,"VisSrcOuterStep", 0, 1, 1, int_type, &(config::OutSrcStep), 1, optional);
-  ParseForParameter(verbose,file,"TargetTemp", 0, 1, 1, double_type, &(Thermostats->TargetTemp), 1, optional);
-  ParseForParameter(verbose,file,"ScaleTempStep", 0, 1, 1, int_type, &(Thermostats->ScaleTempStep), 1, optional);
-  config::EpsWannier = 1e-8;
-
-  // stop conditions
-  //if (config::MaxOuterStep <= 0) config::MaxOuterStep = 1;
-  ParseForParameter(verbose,file,"MaxPsiStep", 0, 1, 1, int_type, &(config::MaxPsiStep), 1, critical);
-  if (config::MaxPsiStep <= 0) config::MaxPsiStep = 3;
-
-  ParseForParameter(verbose,file,"MaxMinStep", 0, 1, 1, int_type, &(config::MaxMinStep), 1, critical);
-  ParseForParameter(verbose,file,"MaxMinStep", 0, 2, 1, double_type, &(config::RelEpsTotalEnergy), 1, critical);
-  ParseForParameter(verbose,file,"MaxMinStep", 0, 3, 1, double_type, &(config::RelEpsKineticEnergy), 1, critical);
-  ParseForParameter(verbose,file,"MaxMinStep", 0, 4, 1, int_type, &(config::MaxMinStopStep), 1, critical);
-  if (config::MaxMinStep <= 0) config::MaxMinStep = config::MaxPsiStep;
-  if (config::MaxMinStopStep < 1) config::MaxMinStopStep = 1;
-  config::MaxMinGapStopStep = 1;
-
-  ParseForParameter(verbose,file,"MaxInitMinStep", 0, 1, 1, int_type, &(config::MaxInitMinStep), 1, critical);
-  ParseForParameter(verbose,file,"MaxInitMinStep", 0, 2, 1, double_type, &(config::InitRelEpsTotalEnergy), 1, critical);
-  ParseForParameter(verbose,file,"MaxInitMinStep", 0, 3, 1, double_type, &(config::InitRelEpsKineticEnergy), 1, critical);
-  ParseForParameter(verbose,file,"MaxInitMinStep", 0, 4, 1, int_type, &(config::InitMaxMinStopStep), 1, critical);
-  if (config::MaxInitMinStep <= 0) config::MaxInitMinStep = config::MaxPsiStep;
-  if (config::InitMaxMinStopStep < 1) config::InitMaxMinStopStep = 1;
-  config::InitMaxMinGapStopStep = 1;
-
-  ParseForParameter(verbose,file, "BoxLength", 0, 3, 3, lower_trigrid, BoxLength, 1, critical); /* Lattice->RealBasis */
-  double * cell_size = new double[6];
-  cell_size[0] = BoxLength[0];
-  cell_size[1] = BoxLength[3];
-  cell_size[2] = BoxLength[4];
-  cell_size[3] = BoxLength[6];
-  cell_size[4] = BoxLength[7];
-  cell_size[5] = BoxLength[8];
-  World::getInstance().setDomain(cell_size);
-  delete[] cell_size;
-  if (1) fprintf(stderr,"\n");
-  config::DoPerturbation = 0;
-  config::DoFullCurrent = 0;
-
-  ParseForParameter(verbose,file,"ECut", 0, 1, 1, double_type, &(config::ECut), 1, critical);
-  ParseForParameter(verbose,file,"MaxLevel", 0, 1, 1, int_type, &(config::MaxLevel), 1, critical);
-  ParseForParameter(verbose,file,"Level0Factor", 0, 1, 1, int_type, &(config::Lev0Factor), 1, critical);
-  if (config::Lev0Factor < 2) {
-    config::Lev0Factor = 2;
-  }
-  ParseForParameter(verbose,file,"RiemannTensor", 0, 1, 1, int_type, &di, 1, critical);
-  if (di >= 0 && di < 2) {
-    config::RiemannTensor = di;
-  } else {
-    fprintf(stderr, "0 <= RiemanTensor < 2: 0 UseNotRT, 1 UseRT");
-    exit(1);
-  }
-  switch (config::RiemannTensor) {
-    case 0: //UseNoRT
-      if (config::MaxLevel < 2) {
-        config::MaxLevel = 2;
-      }
-      config::LevRFactor = 2;
-      config::RTActualUse = 0;
-      break;
-    case 1: // UseRT
-      if (config::MaxLevel < 3) {
-        config::MaxLevel = 3;
-      }
-      ParseForParameter(verbose,file,"RiemannLevel", 0, 1, 1, int_type, &(config::RiemannLevel), 1, critical);
-      if (config::RiemannLevel < 2) {
-        config::RiemannLevel = 2;
-      }
-      if (config::RiemannLevel > config::MaxLevel-1) {
-        config::RiemannLevel = config::MaxLevel-1;
-      }
-      ParseForParameter(verbose,file,"LevRFactor", 0, 1, 1, int_type, &(config::LevRFactor), 1, critical);
-      if (config::LevRFactor < 2) {
-        config::LevRFactor = 2;
-      }
-      config::Lev0Factor = 2;
-      config::RTActualUse = 2;
-      break;
-  }
-  ParseForParameter(verbose,file,"PsiType", 0, 1, 1, int_type, &di, 1, critical);
-  if (di >= 0 && di < 2) {
-    config::PsiType = di;
-  } else {
-    fprintf(stderr, "0 <= PsiType < 2: 0 UseSpinDouble, 1 UseSpinUpDown");
-    exit(1);
-  }
-  switch (config::PsiType) {
-  case 0: // SpinDouble
-    ParseForParameter(verbose,file,"MaxPsiDouble", 0, 1, 1, int_type, &(config::MaxPsiDouble), 1, critical);
-    config::AddPsis = 0;
-    break;
-  case 1: // SpinUpDown
-    if (config::ProcPEGamma % 2) config::ProcPEGamma*=2;
-    ParseForParameter(verbose,file,"MaxPsiUp", 0, 1, 1, int_type, &(config::PsiMaxNoUp), 1, critical);
-    ParseForParameter(verbose,file,"MaxPsiDown", 0, 1, 1, int_type, &(config::PsiMaxNoDown), 1, critical);
-    config::AddPsis = 0;
-    break;
-  }
-
-  // IonsInitRead
-
-  ParseForParameter(verbose,file,"RCut", 0, 1, 1, double_type, &(config::RCut), 1, critical);
-  ParseForParameter(verbose,file,"IsAngstroem", 0, 1, 1, int_type, &(config::IsAngstroem), 1, critical);
-  config::RelativeCoord = 0;
-  config::StructOpt = 0;
-
-
-  // 2. parse the bond graph file if given
-  BG = new BondGraph(IsAngstroem);
-  if (BG->LoadBondLengthTable(BondGraphFileName)) {
-    DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
-  } else {
-    DoLog(0) && (Log() << Verbose(0) << "Bond length table loading failed." << endl);
-  }
-
-  // Routine from builder.cpp
-
-  for (i=MAX_ELEMENTS;i--;)
-    elementhash[i] = NULL;
-  DoLog(0) && (Log() << Verbose(0) << "Parsing Ions ..." << endl);
-  No=0;
-  found = 0;
-  while (getline(*file,zeile,'\n')) {
-    if (zeile.find("Ions_Data") == 0) {
-      DoLog(1) && (Log() << Verbose(1) << "found Ions_Data...begin parsing" << endl);
-      found ++;
-    }
-    if (found > 0) {
-      if (zeile.find("Ions_Data") == 0)
-        getline(*file,zeile,'\n'); // read next line and parse this one
-      istringstream input(zeile);
-      input >> AtomNo;  // number of atoms
-      input >> Z;       // atomic number
-      input >> a;
-      input >> l;
-      input >> l;
-      input >> b;     // element mass
-      elementhash[No] = periode->FindElement(Z);
-      DoLog(1) && (Log() << Verbose(1) << "AtomNo: " << AtomNo << "\tZ: " << Z << "\ta:" << a << "\tl:"  << l << "\b:" << b << "\tElement:" << elementhash[No] << "\t:" << endl);
-      for(i=0;i<AtomNo;i++) {
-        if (!getline(*file,zeile,'\n')) {// parse on and on
-          DoLog(2) && (Log() << Verbose(2) << "Error: Too few items in ionic list of element" << elementhash[No] << "." << endl << "Exiting." << endl);
-          // return 1;
-        } else {
-          //Log() << Verbose(2) << "Reading line: " << zeile << endl;
-        }
-        istringstream input2(zeile);
-        atom *neues = World::getInstance().createAtom();
-        input2 >> neues->x[0]; // x
-        input2 >> neues->x[1]; // y
-        input2 >> neues->x[2]; // z
-        input2 >> l;
-        neues->type = elementhash[No]; // find element type
-        mol->AddAtom(neues);
-      }
-      No++;
-    }
-  }
-  file->close();
-  delete(file);
 };
 
@@ -1050,25 +656,6 @@
     *output << "DoFullCurrent\t" << config::DoFullCurrent << "\t# Do full perturbation" << endl;
     *output << "DoConstrainedMD\t" << config::DoConstrainedMD << "\t# Do perform a constrained (>0, relating to current MD step) instead of unconstrained (0) MD" << endl;
-    *output << "Thermostat\t" << Thermostats->ThermostatNames[Thermostats->Thermostat] << "\t";
-    switch(Thermostats->Thermostat) {
-      default:
-      case None:
-        break;
-      case Woodcock:
-        *output << Thermostats->ScaleTempStep;
-        break;
-      case Gaussian:
-        *output << Thermostats->ScaleTempStep;
-        break;
-      case Langevin:
-        *output << Thermostats->TempFrequency << "\t" << Thermostats->alpha;
-        break;
-      case Berendsen:
-        *output << Thermostats->TempFrequency;
-        break;
-      case NoseHoover:
-        *output << Thermostats->HooverMass;
-        break;
-    };
+    *output << "Thermostat\t" << Thermostats->activeThermostat->name() << "\t";
+    *output << Thermostats->activeThermostat->writeParams();
     *output << "\t# Which Thermostat and its parameters to use in MD case." << endl;
     *output << "CommonWannier\t" << config::CommonWannier << "\t# Put virtual centers at indivual orbits, all common, merged by variance, to grid point, to cell center" << endl;
@@ -1160,5 +747,4 @@
 bool config::SaveMPQC(const char * const filename, const molecule * const mol) const
 {
-  int AtomNo = -1;
   Vector *center = NULL;
   ofstream *output = NULL;
@@ -1193,6 +779,7 @@
     center = mol->DetermineCenterOfAll();
     // output of atoms
-    AtomNo = 0;
-    mol->ActOnAllAtoms( &atom::OutputMPQCLine, (ostream * const) output, (const Vector *)center, &AtomNo );
+    for(molecule::const_iterator iter = mol->begin(); iter!=mol->end();++iter){
+      (*iter)->OutputMPQCLine(output,center);
+    }
     delete(center);
     *output << "\t}" << endl;
@@ -1235,6 +822,7 @@
     center = mol->DetermineCenterOfAll();
     // output of atoms
-    AtomNo = 0;
-    mol->ActOnAllAtoms( &atom::OutputMPQCLine, (ostream * const) output, (const Vector *)center, &AtomNo );
+    for(molecule::const_iterator iter = mol->begin(); iter!=mol->end();++iter){
+      (*iter)->OutputMPQCLine(output,center);
+    }
     delete(center);
     *output << "\t}" << endl;
@@ -1279,6 +867,6 @@
     AtomNo = 0;
     for (molecule::const_iterator iter = (*MolRunner)->begin(); iter != (*MolRunner)->end(); ++iter) {
-      sprintf(name, "%2s%2d",(*iter)->type->symbol, elementNo[(*iter)->type->Z]);
-      elementNo[(*iter)->type->Z] = (elementNo[(*iter)->type->Z]+1) % 100;   // confine to two digits
+      sprintf(name, "%2s%2d",(*iter)->getType()->getSymbol().c_str(), elementNo[(*iter)->getType()->getAtomicNumber()]);
+      elementNo[(*iter)->getType()->getAtomicNumber()] = (elementNo[(*iter)->getType()->getAtomicNumber()]+1) % 100;   // confine to two digits
       fprintf(f,
              "ATOM %6u %-4s %4s%c%4u    %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s\n",
@@ -1288,11 +876,11 @@
              'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
              MolNo,         /* residue sequence number */
-             (*iter)->node->at(0),                 /* position X in Angstroem */
-             (*iter)->node->at(1),                 /* position Y in Angstroem */
-             (*iter)->node->at(2),                 /* position Z in Angstroem */
-             (double)(*iter)->type->Valence,         /* occupancy */
-             (double)(*iter)->type->NoValenceOrbitals,          /* temperature factor */
+             (*iter)->at(0),                 /* position X in Angstroem */
+             (*iter)->at(1),                 /* position Y in Angstroem */
+             (*iter)->at(2),                 /* position Z in Angstroem */
+             (double)(*iter)->getType()->getValence(),         /* occupancy */
+             (double)(*iter)->getType()->getNoValenceOrbitals(),          /* temperature factor */
              "0",            /* segment identifier */
-             (*iter)->type->symbol,    /* element symbol */
+             (*iter)->getType()->getSymbol().c_str(),    /* element symbol */
              "0");           /* charge */
       AtomNo++;
@@ -1332,6 +920,6 @@
   AtomNo = 0;
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-    sprintf(name, "%2s%2d",(*iter)->type->symbol, elementNo[(*iter)->type->Z]);
-    elementNo[(*iter)->type->Z] = (elementNo[(*iter)->type->Z]+1) % 100;   // confine to two digits
+    sprintf(name, "%2s%2d",(*iter)->getType()->getSymbol().c_str(), elementNo[(*iter)->getType()->getAtomicNumber()]);
+    elementNo[(*iter)->getType()->getAtomicNumber()] = (elementNo[(*iter)->getType()->getAtomicNumber()]+1) % 100;   // confine to two digits
     fprintf(f,
            "ATOM %6u %-4s %4s%c%4u    %8.3f%8.3f%8.3f%6.2f%6.2f      %4s%2s%2s\n",
@@ -1341,11 +929,11 @@
            'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
            0,         /* residue sequence number */
-           (*iter)->node->at(0),                 /* position X in Angstroem */
-           (*iter)->node->at(1),                 /* position Y in Angstroem */
-           (*iter)->node->at(2),                 /* position Z in Angstroem */
-           (double)(*iter)->type->Valence,         /* occupancy */
-           (double)(*iter)->type->NoValenceOrbitals,          /* temperature factor */
+           (*iter)->at(0),                 /* position X in Angstroem */
+           (*iter)->at(1),                 /* position Y in Angstroem */
+           (*iter)->at(2),                 /* position Z in Angstroem */
+           (double)(*iter)->getType()->getValence(),         /* occupancy */
+           (double)(*iter)->getType()->getNoValenceOrbitals(),          /* temperature factor */
            "0",            /* segment identifier */
-           (*iter)->type->symbol,    /* element symbol */
+           (*iter)->getType()->getSymbol().c_str(),    /* element symbol */
            "0");           /* charge */
     AtomNo++;
@@ -1390,7 +978,7 @@
     *output << mol->name << "\t";
     *output << 0 << "\t";
-    *output << (*iter)->node->at(0) << "\t" << (*iter)->node->at(1) << "\t" << (*iter)->node->at(2) << "\t";
-    *output << static_cast<double>((*iter)->type->Valence) << "\t";
-    *output << (*iter)->type->symbol << "\t";
+    *output << (*iter)->at(0) << "\t" << (*iter)->at(1) << "\t" << (*iter)->at(2) << "\t";
+    *output << static_cast<double>((*iter)->getType()->getValence()) << "\t";
+    *output << (*iter)->getType()->getSymbol() << "\t";
     for (BondList::iterator runner = (*iter)->ListOfBonds.begin(); runner != (*iter)->ListOfBonds.end(); runner++)
       *output << (*runner)->GetOtherAtom(*iter)->nr << "\t";
@@ -1462,7 +1050,7 @@
         *output << (*MolWalker)->name << "\t";
         *output << MolCounter+1 << "\t";
-        *output << (*iter)->node->at(0) << "\t" << (*iter)->node->at(1) << "\t" << (*iter)->node->at(2) << "\t";
-        *output << (double)(*iter)->type->Valence << "\t";
-        *output << (*iter)->type->symbol << "\t";
+        *output << (*iter)->at(0) << "\t" << (*iter)->at(1) << "\t" << (*iter)->at(2) << "\t";
+        *output << (double)(*iter)->getType()->getValence() << "\t";
+        *output << (*iter)->getType()->getSymbol() << "\t";
         for (BondList::iterator runner = (*iter)->ListOfBonds.begin(); runner != (*iter)->ListOfBonds.end(); runner++)
           *output << LocalNotoGlobalNoMap[ (*runner)->GetOtherAtom((*iter))->getId() ] << "\t";
@@ -1526,9 +1114,7 @@
     for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
       src[N++] = (*ListRunner)->IndexNr;
-      (*ListRunner)->Translate(&(*ListRunner)->Center);
     }
     mol = World::getInstance().createMolecule();
     mol->SetNameFromFilename(ConfigFileName);
-    molecules->SimpleMultiMerge(mol, src, N);
     //mol->CalculateOrbitals(*this);
     delete[](src);
